<template>
  <div class="activity-card" @click="openActivity">    
    <transition name="fade">
      <ActivityEndModal v-if="showModal" :activity="activity" @close="closeModal" @end="updateList"/>
    </transition>
    <div class="card">
      <img src="@/assets/img/activity1.jpg">
      <label>{{activity.name}}</label>
    </div>
    <div class="overlay">
      <button v-if="activity.enable" class="close-btn" @click="openModal">Kết thúc</button>
      <button v-else class="report-btn" @click="toReport">Báo cáo</button>
    </div>
  </div>
</template>

<script>
import ActivityEndModal from '@/components/ActivityEndModal.vue';

export default {
  name: "ActivityCard",
  components: {
    ActivityEndModal
  },
  props: {
    activity: Object
  },
  data(){
    return {
      showModal: false
    }
  },
  methods: {
    openModal(){
      this.showModal = true
    },
    closeModal(){
      this.showModal = false
    },
    toReport(){
      this.$router.push({name: 'Report', query: {actitivy: this.activity.name}})
    },
    updateList(){
      this.$emit('end')
      this.showModal = false
    }
  }
}
</script>

<style scoped>
.activity-card {
  height: 160px;
  width: 160px;
  box-shadow: 0px 0px 10px #ddd;
  border-radius: 10px;
  margin: 10px;
  display: flex;
  position: relative;
  overflow: hidden;
}

.fade-enter-from, .fade-leave-to {
  opacity: 0;
}

.fade-enter-active, .fade-leave-active {
  transition: opacity .2s ease;
}

.card {  
  transition: .5s ease;
  position: relative;
  width: 100%;
  height: 100%;
}

.card > img {
  width: 100%;
  height: 100%;
  z-index: 1;  
  object-fit: fill;
}
.card > label
{
  position: absolute;
  bottom: 0;
  left: 0;
  width: calc(100%-20px);
  z-index: 2;
  padding: 10px;
}
.overlay{
  position: absolute;
  left: 0;
  right: 0;
  top: 0;
  bottom: 0;
  overflow: hidden;
  width: 100%;
  height: 100%;  
  opacity: 0;
  transition: .2s ease;
}

.activity-card:hover .card {
  filter: blur(2px);
}
.activity-card:hover .overlay {
  opacity: 1;
}


.overlay > button {  
  position: absolute;
  top: 50%;
  left: 50%;
  transform: translate(-50%,-50%);
  padding: 8px;
  border-radius: 5px;
}
.close-btn{
  border: 1px solid red;
  background-color: #f22;  
  color: white;
}

.close-btn:hover{
  cursor: pointer;
}

.report-btn {
  
  border: 1px solid green;
  background-color: #2f2;  
  color: white;
}

.activity-card > label {
  z-index: 1;
  font-size: 1em;
}
</style>